import test, { AfterInterface, BeforeInterface, ExecutionContext, ImplementationResult } from 'ava';
import * as fc from 'fast-check';
export { fc, test };
declare type NonEmptyArray<A> = A[] & {
    0: A;
};
declare type ArbitraryTuple<Ts extends NonEmptyArray<any>> = {
    [P in keyof Ts]: fc.Arbitrary<Ts[P]>;
};
declare type Prop<Context, Ts extends NonEmptyArray<any>> = (t: ExecutionContext<Context>, ...args: Ts) => ImplementationResult;
declare type PropertyTest<Context> = <Ts extends NonEmptyArray<any>>(label: string, arbitraries: ArbitraryTuple<Ts>, prop: Prop<Context, Ts>, params?: fc.Parameters<Ts>) => void;
declare type AvaModifierWhitelist = 'only' | 'failing' | 'skip' | 'serial';
export declare type PropertyTestInterface<Context> = PropertyTest<Context> & {
    [Modifier in AvaModifierWhitelist]: PropertyTest<Context>;
} & {
    before: BeforeInterface<Context>;
    after: AfterInterface<Context>;
};
export declare const testProp: PropertyTestInterface<unknown>;
